#!/usr/bin/env python
# -*- coding: ISO8859-1 -*
#
############################################################################
###Programme d'envoi des donnees IPMI du bullion a vCops
###Code par Guillaume Bellosguardo / Virtualisation Competence Center (Pierre Fumery) - Bull Grenoble
###guillaume.bellosguardo@ext.bull.net
###
### Se rfrer a la documentation
### VERSION 1.0
import sys
if sys.version_info[0] == 2 and sys.version_info[1] >= 6 :
	pass
else :
	print('ERROR - INCOMPATIBLE PYTHON VERSION - YOU NEED 2.6+ AND YOU GOT ' + str(sys.version))
	sys.exit()

import bulliontovcop
import syslog
import time
import yapdi

COMMAND_START = 'start'
COMMAND_STOP = 'stop'
COMMAND_RESTART = 'restart'
COMMAND_STATUS ='status'

def usage():
	print("USAGE: python %s %s|%s|%s|%s" % (sys.argv[0], COMMAND_START, COMMAND_STOP, COMMAND_RESTART,COMMAND_STATUS))

# Invalid executions
if len(sys.argv) < 2 or sys.argv[1] not in [COMMAND_START, COMMAND_STOP, COMMAND_RESTART, COMMAND_STATUS]:
	usage()
	exit()

if sys.argv[1] == COMMAND_START:
	daemon = yapdi.Daemon()

	# Check whether an instance is already running
	if daemon.status():
		print("An instance is already running.")
		exit()
	retcode = daemon.daemonize()

	# Execute if daemonization was successful else exit
	if retcode == yapdi.OPERATION_SUCCESSFUL:
		bulliontovcop.Run()
	else:
		print('Daemonization failed')

elif sys.argv[1] == COMMAND_STOP:
	daemon = yapdi.Daemon()

	# Check whether no instance is running
	if not daemon.status():
		print("No instance running.")
		exit()
	retcode = daemon.kill()
	if retcode == yapdi.OPERATION_FAILED:
		print('Trying to stop running instance failed')
	else:
		print('Daemon stopped')

elif sys.argv[1] == COMMAND_RESTART:
	daemon = yapdi.Daemon()
	retcode = daemon.restart()

	# Execute if daemonization was successful else exit
	if retcode == yapdi.OPERATION_SUCCESSFUL:
		bulliontovcop.Run()
	else:
		print('Daemonization failed')

elif sys.argv[1]== COMMAND_STATUS:
	daemon=yapdi.Daemon()
	if daemon.status():
		print('bulliontovcop is running')
	else:
		print('bulliontovcop is not running')
